#ifndef __Common_BaseFunctions_H__
#define __Common_BaseFunctions_H__

#include "../utils/utils.h"

namespace Filtering { namespace Functions {
 
typedef void (Memset)(Byte *pPlane, int nPitch, int nWidth, int nHeight, Byte value);

typedef void (Copy)(Byte *pDst, int nDstPitch, const Byte *pSrc, int nSrcPitch,
                    int nWidth, int Height);

typedef void (Prefetch)(const Byte *pDst, int nWidth);

Memset memset_c;
Copy copy_c;
Prefetch prefetch_nothing_c;

}

// don't ask
extern "C" Functions::Memset memset8_mmx;
extern "C" Functions::Memset memset8_isse;
extern "C" Functions::Memset memset8_3dnow;

extern "C" Functions::Copy copy8_mmx;
extern "C" Functions::Copy copy8_isse;
extern "C" Functions::Copy copy8_3dnow;

extern "C" Functions::Prefetch prefetch_c;
extern "C" Functions::Prefetch prefetch_isse;

}

#endif
