%INCLUDE "common.asm"

SECTION .rodata:
ALIGN 16
   MT_BYTE_80     : TIMES 16 DB 0x80

%MACRO MT_SUPPORT_DIFF_ROLLED 1
   movq                 mm0, [edi + eax]
   movq                 mm1, [esi + eax]
   
   psubb                mm0, mm7
   psubb                mm1, mm7
   %1                   mm0, mm1
   paddb                mm0, mm7
   
   movq                 [edi + eax], mm0
%ENDMACRO

%MACRO MT_SUPPORT_DIFF 2
   movq                 mm0, [edi + eax + %1]
   movq                 mm4, [esi + eax + %1]

   movq                 mm1, [edi + eax + %1 + 8]
   movq                 mm5, [esi + eax + %1 + 8]

   psubb                mm0, mm7
   psubb                mm4, mm7

   psubb                mm1, mm7
   psubb                mm5, mm7

   %2                   mm0, mm4
   %2                   mm1, mm5

   paddb                mm0, mm7
   paddb                mm1, mm7
   
   movq                 [edi + eax + %1], mm0
   movq                 [edi + eax + %1 + 8], mm1
%ENDMACRO

%MACRO MT_SUPPORT_DIFF_UNROLLED 3
   %1                   edi + eax + 128
   %2                   esi + eax + 128

   MT_SUPPORT_DIFF      0, %3
   MT_SUPPORT_DIFF      16, %3
   MT_SUPPORT_DIFF      32, %3
   MT_SUPPORT_DIFF      48, %3
%ENDMACRO

%MACRO MT_SUPPORT_COMMON 3
   MT_SET_STACK         0, edi, esi
   .pDst                PARAM(1)
   .nDstPitch           PARAM(2)
   .pSrc                PARAM(3)
   .nSrcPitch           PARAM(4)
   .nWidth              PARAM(5)
   .nHeight             PARAM(6)
   
   movq                 mm7, [MT_BYTE_80]  
   
   mov                  edi, [esp + .pDst]
   mov                  esi, [esp + .pSrc]
   
   MT_UNROLL_INPLACE_WIDTH    {MT_ %+ %1 %+ _UNROLLED %2, %3}, MT_ %+ %1 %+ _ROLLED, MT_ %+ %1 %+ _ENDLINE
      
   MT_REL_STACK
%ENDMACRO