#include "forms.h"
#include <ostream>

namespace Filtering { namespace MaskTools { namespace Helpers { namespace Forms {

static String IntegerToString(int n)
{
   char buffer[10]; /* enough */
   sprintf(buffer, "%i", n);
   buffer[9] = 0;   /* just to be on the safe side */
   return buffer;
}

static String &append_vector(String &str, int nX, int nY)
{
   return str.append(IntegerToString(nX)).append(" ").append(IntegerToString(nY)).append(" ");
}

String CircleToString(int nRadius)
{
   String result = "";

   for ( int i = -nRadius; i <= nRadius; i++ )
      for ( int j = -nRadius; j <= nRadius; j++ )
         if ( i * i + j * j <= nRadius * nRadius && ( i != 0 || j != 0 ) )
            result = append_vector(result, i, j);

   return result;
}

String SquareToString(int nRadius)
{
   String result = "";

   for ( int i = -nRadius; i <= nRadius; i++ )
      for ( int j = -nRadius; j <= nRadius; j++ )
         if ( i != 0 || j != 0 ) 
            result = append_vector(result, i, j);
 
   return result;
}

String DiamondToString(int nRadius)
{
   String result = "";

   for ( int i = -nRadius; i <= nRadius; i++ )
      for ( int j = -nRadius; j <= nRadius; j++ )
         if ( abs(i) + abs(j) <= nRadius && ( i != 0 || j != 0 ) )
            result = append_vector(result, i, j);
 
   return result;
}

String RectangleToString(int nHorizontalRadius, int nVerticalRadius)
{
   String result = "";

   for ( int i = -nHorizontalRadius; i <= nHorizontalRadius; i++ )
      for ( int j = -nVerticalRadius; j <= nVerticalRadius; j++ )
         if ( i != 0 || j != 0 )
            result = append_vector(result, i, j);
 
   return result;
}

String LosangeToString(int nHorizontalRadius, int nVerticalRadius)
{
   String result = "";

   for ( int i = -nHorizontalRadius; i <= nHorizontalRadius; i++ )
      for ( int j = -nVerticalRadius; j <= nVerticalRadius; j++ )
         if ( abs(i) * nVerticalRadius + abs(j) * nHorizontalRadius <= nHorizontalRadius * nVerticalRadius && ( i != 0 || j != 0 ) )
            result = append_vector(result, i, j);
 
   return result;
}

String EllipseToString(int nHorizontalRadius, int nVerticalRadius)
{
   String result = "";

   for ( int i = -nHorizontalRadius; i <= nHorizontalRadius; i++ )
      for ( int j = -nVerticalRadius; j <= nVerticalRadius; j++ )
         if ( i * i * nVerticalRadius * nVerticalRadius + j * j * nHorizontalRadius * nHorizontalRadius <= nHorizontalRadius * nHorizontalRadius * nVerticalRadius * nVerticalRadius && ( i != 0 || j != 0 ))
            result = append_vector(result, i, j);
 
   return result;
}

} } } }